#ifndef __BLUEGATE_L__
#define __BLUEGATE_L__

#ifdef __cplusplus
extern "C"
{
#endif

/* DLL support */
#ifndef ___EXPORT
	#define ___EXPORT
#endif

___EXPORT BOOL BlueGateL_Open(int unit);
___EXPORT void BlueGateL_Close(int unit);
___EXPORT void BlueGateL_CloseAll();
___EXPORT int BlueGateL_Find();

___EXPORT ULONG BlueGateL_WritePWM(int unit, int ch, ULONG data);
___EXPORT ULONG BlueGateL_ReadPWM(int unit, int ch);
___EXPORT void  BlueGateL_EnablePWM(int unit, int ch, BOOL enable);
___EXPORT void  BlueGateL_EnableExtTrig(int unit,BOOL enable);

___EXPORT ULONG BlueGateL_ReadIn(int unit);
___EXPORT ULONG BlueGateL_ReadOut(int unit);
___EXPORT ULONG BlueGateL_WriteOut(int unit,ULONG data);
___EXPORT void  BlueGateL_EnableOut(int unit,BOOL enable);
___EXPORT BOOL BlueGateL_ReadInBit(int unit,int bit);
___EXPORT BOOL BlueGateL_WriteOutBit(int unit,int bit,BOOL status);

___EXPORT int BlueGateL_ReadId(int unit);
___EXPORT ULONG BlueGateL_ReadIo(int unit);
___EXPORT ULONG BlueGateL_WriteIo(int unit,ULONG data);

___EXPORT void BlueGateL_EnableIntr(int unit,BOOL enable);
___EXPORT ULONG BlueGateL_WaitForIntr(int unit,ULONG timeout_msec,ULONG *input);
___EXPORT ULONG BlueGateL_ReadIntrStatus(int unit);
___EXPORT void BlueGateL_SetIntrMask(int unit,ULONG mask);
___EXPORT void BlueGateL_ClearIntrStatus(int unit);
___EXPORT BOOL BlueGateL_CreateThread(int unit,HWND hwnd,UINT msg);
___EXPORT void BlueGateL_CloseThread(int unit);

___EXPORT void BlueGateL_Delay(ULONG microsec);

#ifdef __cplusplus
}
#endif

#endif