// BGTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BGTest.h"
#include "BGTestDlg.h"

//#include "BlueGate.h"
#include "BGateL.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBGTestDlg dialog

CBGTestDlg::CBGTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBGTestDlg::IDD, pParent)
{
	ReadData=0;
	OldReadData=0;
	WriteData=0;
	m_nCallNum=0;
	m_nBlueGateID=-1;
	m_nPWMdata = 0;
	m_nCh = 1;

	//{{AFX_DATA_INIT(CBGTestDlg)
	m_bCheckI0 = FALSE;
	m_bCheckI1 = FALSE;
	m_bCheckI2 = FALSE;
	m_bCheckI3 = FALSE;
	m_bCheckI4 = FALSE;
	m_bCheckI5 = FALSE;
	m_bCheckI6 = FALSE;
	m_bCheckI7 = FALSE;
	m_bCheckO0 = FALSE;
	m_bCheckO1 = FALSE;
	m_bCheckO2 = FALSE;
	m_bCheckO3 = FALSE;
	m_bCheckO4 = FALSE;
	m_bCheckO5 = FALSE;
	m_bCheckO6 = FALSE;
	m_bCheckO7 = FALSE;
	m_bCheckO8 = FALSE;
	m_bCheckAuto = FALSE;
	m_strInputHex = _T("");
	m_strOutputEdit = _T("");
	m_bCheckCh1En = FALSE;
	m_bCheckCh2En = FALSE;
	m_bCheckCh3En = FALSE;
	m_strCh1 = _T("");
	m_strCh2 = _T("");
	m_strCh3 = _T("");
	m_bCheckStrbEn = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBGTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBGTestDlg)
	DDX_Check(pDX, IDC_CHECK_I0, m_bCheckI0);
	DDX_Check(pDX, IDC_CHECK_I1, m_bCheckI1);
	DDX_Check(pDX, IDC_CHECK_I2, m_bCheckI2);
	DDX_Check(pDX, IDC_CHECK_I3, m_bCheckI3);
	DDX_Check(pDX, IDC_CHECK_I4, m_bCheckI4);
	DDX_Check(pDX, IDC_CHECK_I5, m_bCheckI5);
	DDX_Check(pDX, IDC_CHECK_I6, m_bCheckI6);
	DDX_Check(pDX, IDC_CHECK_I7, m_bCheckI7);
	DDX_Check(pDX, IDC_CHECK_O0, m_bCheckO0);
	DDX_Check(pDX, IDC_CHECK_O1, m_bCheckO1);
	DDX_Check(pDX, IDC_CHECK_O2, m_bCheckO2);
	DDX_Check(pDX, IDC_CHECK_O3, m_bCheckO3);
	DDX_Check(pDX, IDC_CHECK_O4, m_bCheckO4);
	DDX_Check(pDX, IDC_CHECK_O5, m_bCheckO5);
	DDX_Check(pDX, IDC_CHECK_O6, m_bCheckO6);
	DDX_Check(pDX, IDC_CHECK_O7, m_bCheckO7);
	DDX_Check(pDX, IDC_CHECK_O8, m_bCheckO8);
	DDX_Check(pDX, IDC_CHECK_AUTO, m_bCheckAuto);
	DDX_Text(pDX, IDC_STATIC_INPUT, m_strInputHex);
	DDX_Text(pDX, IDC_EDIT_OUT, m_strOutputEdit);
	DDV_MaxChars(pDX, m_strOutputEdit, 2);
	DDX_Check(pDX, IDC_CHECK_CH1EN, m_bCheckCh1En);
	DDX_Check(pDX, IDC_CHECK_CH2EN, m_bCheckCh2En);
	DDX_Check(pDX, IDC_CHECK_CH3EN, m_bCheckCh3En);
	DDX_Text(pDX, IDC_EDIT_CH1, m_strCh1);
	DDV_MaxChars(pDX, m_strCh1, 2);
	DDX_Text(pDX, IDC_EDIT_CH2, m_strCh2);
	DDV_MaxChars(pDX, m_strCh2, 2);
	DDX_Text(pDX, IDC_EDIT_CH3, m_strCh3);
	DDV_MaxChars(pDX, m_strCh3, 2);
	DDX_Check(pDX, IDC_CHECK_STRB, m_bCheckStrbEn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBGTestDlg, CDialog)
	//{{AFX_MSG_MAP(CBGTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_OUT, OnButtonOut)
	ON_BN_CLICKED(IDC_CHECK_AUTO, OnCheckAuto)
	ON_BN_CLICKED(IDC_BUTTON_BDID, OnButtonBdid)
	ON_BN_CLICKED(IDC_BUTTON_INTR, OnButtonIntr)
	ON_BN_CLICKED(IDC_BUTTON_STOPINTR, OnButtonStopintr)
	ON_BN_CLICKED(IDC_BUTTON_CH1, OnButtonCh1)
	ON_BN_CLICKED(IDC_BUTTON_CH2, OnButtonCh2)
	ON_BN_CLICKED(IDC_BUTTON_CH3, OnButtonCh3)
	ON_BN_CLICKED(IDC_CHECK_CH1EN, OnCheckCh1en)
	ON_BN_CLICKED(IDC_CHECK_CH2EN, OnCheckCh2en)
	ON_BN_CLICKED(IDC_CHECK_CH3EN, OnCheckCh3en)
	ON_BN_CLICKED(IDC_CHECK_STRB, OnCheckStrb)
	ON_BN_CLICKED(IDC_BUTTON_RUN, OnButtonRun)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	//}}AFX_MSG_MAP
	ON_MESSAGE( USER_MSG, OnUserMsg )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBGTestDlg message handlers

BOOL CBGTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	/////////////////////////////////////////////////////////////
	// Initialize BlueGates.
	//
	char buf[20];
	int bgnum;
	CString report;

	bgnum = BlueGateL_Find();
	if(bgnum==0)
	{
		sprintf(buf,"%d",bgnum);
		report = "Found no card";
		MessageBox(report);
		return TRUE;
	}
	/*if(bgnum<2)
	{
		sprintf(buf,"%d",bgnum);
		report = "Found : " + CString(buf) + " cards.\n";
		report += "This program requires to two cards.";
		MessageBox(report);
		return TRUE;
	}*/

	m_nBlueGateID = 0;
	if(BlueGateL_Open(m_nBlueGateID)==FALSE)
	{
		sprintf(buf,"%d",m_nBlueGateID);
		report = "No device " + CString(buf) + "\r\n";
		MessageBox(report);
		m_nBlueGateID = -1;
	}
	else
	{
		BlueGateL_SetIntrMask(m_nBlueGateID,0); // interrupt mask
		BlueGateL_EnableIntr(m_nBlueGateID,FALSE); // disable interrupt
		BlueGateL_WritePWM(m_nBlueGateID,0,0xffffff);

		SetTimer(1,50,NULL);
		SetTimer(2,500,NULL);
	}

	m_bCheckAuto = FALSE; // Set Auto Output
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBGTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBGTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBGTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBGTestDlg::RefreshCheck()
{
	// ȭ ͸  ...
	// Ϻε͸ ٲٸ ġʴ    ?
	UpdateData(TRUE);

	/////////////////////////////////////////////////////
	// Read BlueGate Input Port Data
	ReadData=BlueGateL_ReadIn(m_nBlueGateID);
	//ReadData=~(ReadData); // bit toggle
	//ReadData = ReadData & 0x0000ffff; // reset unwanted bits

	// Input Hex display
	char buf[10];
	sprintf(buf,"%04lx",ReadData);
	m_strInputHex = CString(buf);

	// Input Check button 0
	m_bCheckI0=(ReadData & 0x0001)?TRUE:FALSE;
	// Input Check button 1
	m_bCheckI1=(ReadData & 0x0002)?TRUE:FALSE;
	// Input Check button 2
	m_bCheckI2=(ReadData & 0x0004)?TRUE:FALSE;
	// Input Check button 3
	m_bCheckI3=(ReadData & 0x0008)?TRUE:FALSE;
	// Input Check button 4
	m_bCheckI4=(ReadData & 0x0010)?TRUE:FALSE;
	// Input Check button 5
	m_bCheckI5=(ReadData & 0x0020)?TRUE:FALSE;
	// Input Check button 6
	m_bCheckI6=(ReadData & 0x0040)?TRUE:FALSE;
	// Input Check button 7
	m_bCheckI7=(ReadData & 0x0080)?TRUE:FALSE;

	/////////////////////////////////////////////////////
	// Read BlueGate Output Data
	// Output Check button 0
	m_bCheckO0=(WriteData & 0x000001)?TRUE:FALSE;
	// Output Check button 1
	m_bCheckO1=(WriteData & 0x000002)?TRUE:FALSE;
	// Output Check button 2
	m_bCheckO2=(WriteData & 0x000004)?TRUE:FALSE;
	// Output Check button 3
	m_bCheckO3=(WriteData & 0x000008)?TRUE:FALSE;
	// Output Check button 4
	m_bCheckO4=(WriteData & 0x000010)?TRUE:FALSE;
	// Output Check button 5
	m_bCheckO5=(WriteData & 0x000020)?TRUE:FALSE;
	// Output Check button 6
	m_bCheckO6=(WriteData & 0x000040)?TRUE:FALSE;
	// Output Check button 7
	m_bCheckO7=(WriteData & 0x000080)?TRUE:FALSE;

	/////////////////////////////////////////////////
	// Check button ٽ ׸.
	UpdateData(FALSE);
}

void CBGTestDlg::OnOK() 
{
	// TODO: Add extra validation here
	if(m_nBlueGateID>=0)
	{
		BlueGateL_WriteOut(m_nBlueGateID,0);
		BlueGateL_Close(m_nBlueGateID);
	}

	KillTimer(1);
	KillTimer(2);
	KillTimer(3);

	CDialog::OnOK();
}

void CBGTestDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(m_nBlueGateID>=0)
	{
		BlueGateL_WriteOut(m_nBlueGateID,0);
		BlueGateL_Close(m_nBlueGateID);
	}

	KillTimer(1);
	KillTimer(2);
	KillTimer(3);

	CDialog::OnCancel();
}

void CBGTestDlg::BlueGateOutput()
{
	static int i=0;
	static int time=0;

	WriteData = 1 << i++;
	if(time==1)
		WriteData = ~(WriteData);

	BlueGateL_WriteOut(m_nBlueGateID,WriteData);

	if(i>=8)
	{
		i=0;
		time=(time==1)?0:1;
	}
}

void CBGTestDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==1)
		RefreshCheck();

	if(nIDEvent==2)
	{
		if(m_bCheckAuto)
			BlueGateOutput();
	}

	if(nIDEvent==3)
	{
		BlueGateL_EnablePWM(m_nBlueGateID,m_nCh,TRUE);
		BlueGateL_WritePWM(m_nBlueGateID,m_nCh,m_nPWMdata);
		m_nPWMdata+=0x20;
		if(m_nPWMdata>0xff)
		{
			m_nPWMdata=0;
			BlueGateL_EnablePWM(m_nBlueGateID,m_nCh,FALSE);
			if(++m_nCh>3)
				m_nCh=1;
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CBGTestDlg::OnButtonOut() 
{
	// TODO: Add your control notification handler code here

	// Auto Output ƴ 쿡 ...
	if(!m_bCheckAuto && m_nBlueGateID>=0)
	{
		UpdateData(FALSE);
		sscanf(m_strOutputEdit,"%2x",&WriteData);
		BlueGateL_WriteOut(m_nBlueGateID,WriteData);
	}
}

void CBGTestDlg::OnCheckAuto() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_strOutputEdit.Empty(); // Clear output editbox.
	UpdateData(FALSE);
}

void CBGTestDlg::OnButtonBdid() 
{
	// TODO: Add your control notification handler code here
	ULONG data;
	char buf[50];
	data = BlueGateL_ReadId(m_nBlueGateID);
	sprintf(buf,"Board ID : %08lx", data);
	MessageBox(buf);
}

void CBGTestDlg::OnButtonIntr() 
{
	// TODO: Add your control notification handler code here
	BlueGateL_EnableIntr(m_nBlueGateID,TRUE); // disable interrupt
	BlueGateL_CreateThread(m_nBlueGateID,m_hWnd,USER_MSG);
}

void CBGTestDlg::OnUserMsg( UINT wParam, LONG lParam )
{
	char buf[50];

	sprintf(buf,"Interrupt !!!\nwParam : %08lx \nlParam : %08lx\n", wParam, lParam);
	MessageBox( buf );
	//BlueGate_EnableIntr(m_nBlueGateID,FALSE); // disable interrupt
	//BlueGate_CloseThread(m_nBlueGateID);
}

void CBGTestDlg::OnButtonStopintr() 
{
	// TODO: Add your control notification handler code here
	BlueGateL_EnableIntr(m_nBlueGateID,FALSE); // disable interrupt
	BlueGateL_CloseThread(m_nBlueGateID);
}

void CBGTestDlg::OnButtonCh1() 
{
	// TODO: Add your control notification handler code here
	ULONG data;

	if(m_nBlueGateID>=0)
	{
		UpdateData(FALSE);
		sscanf(m_strCh1,"%2x",&data);
		BlueGateL_WritePWM(m_nBlueGateID,1,data);
	}	
}

void CBGTestDlg::OnButtonCh2() 
{
	// TODO: Add your control notification handler code here
	ULONG data;

	if(m_nBlueGateID>=0)
	{
		UpdateData(FALSE);
		sscanf(m_strCh2,"%2x",&data);
		BlueGateL_WritePWM(m_nBlueGateID,2,data);
	}	
}

void CBGTestDlg::OnButtonCh3() 
{
	// TODO: Add your control notification handler code here
	ULONG data;

	if(m_nBlueGateID>=0)
	{
		UpdateData(FALSE);
		sscanf(m_strCh3,"%2x",&data);
		BlueGateL_WritePWM(m_nBlueGateID,3,data);
	}	
}

void CBGTestDlg::OnCheckCh1en() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	BlueGateL_EnablePWM(m_nBlueGateID,1,m_bCheckCh1En);
}

void CBGTestDlg::OnCheckCh2en() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	BlueGateL_EnablePWM(m_nBlueGateID,2,m_bCheckCh2En);
}

void CBGTestDlg::OnCheckCh3en() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	BlueGateL_EnablePWM(m_nBlueGateID,3,m_bCheckCh3En);
}

void CBGTestDlg::OnCheckStrb() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	BlueGateL_EnableExtTrig(m_nBlueGateID,m_bCheckStrbEn);	
}

void CBGTestDlg::OnButtonRun() 
{
	// TODO: Add your control notification handler code here
	SetTimer(3,400,NULL);
}

void CBGTestDlg::OnButtonStop() 
{
	// TODO: Add your control notification handler code here
	m_bCheckCh1En = FALSE;
	BlueGateL_EnablePWM(m_nBlueGateID,1,m_bCheckCh1En);
	UpdateData(FALSE);
	KillTimer(3);
}
